class
	GCD_EXAMPLES

feature -- Status Report
	gcd (a, b: INTEGER): INTEGER
			-- Greatest common divisor of `a` and `b`
		require
			a > 0; b > 0
			a_negative: a < 0
		local
			x, y: INTEGER
		do
			from
				x := a; y := b
			until
				x = y
			loop
				if x > y then
					x := x - y
				else
					y := y - x
				end
			end

			Result := x
		ensure
				-- Result is the greatest common divisor of a and b
		end

	gcd_with_loop_assertions (a, b: INTEGER): INTEGER
			-- Greatest common divisor of `a` and `b`
		require
			a > 0; b > 0
		local
			x, y: INTEGER
		do
			from
				x := a; y := b
			invariant
				x > 0; y > 0
					-- The pair <x, y> has the same greatest common divisor as the pair <a, b>
			variant
				x.max (y)
			until
				x = y
			loop
				if x > y then
					x := x - y
				else
					y := y - x
				end
			end

			Result := x
		ensure
				-- Result is the greatest common divisor of a and b
		end

end
